;F_SDU.inc	;  

.equ	XTAL	= 4000000	;4MHz

.equ	Channels	= 4	; -  
.equ	Mask	= 3
.equ	Fading	= 1		;   
.equ	Attack	= Channels - Fading	;   

.equ	LED_DDR		= DDRD
.equ	LED_PORT	= PortD
.equ	LED_Y	= 5
.equ	LED_R	= 4
.equ	LED_G	= 3
.equ	LED_B	= 2
;.equ	LED_T	= 0

; ! R0	;   LPM
.def	Cnt_Tmp	= R1	;      
.def	RED		= R2	; BAM-  
.def	GREEN	= R3	; BAM-  
.def	BLUE	= R4	; BAM-  
.def	YELLOW	= R5	; BAM-  
.def	NULL	= R15	;  
.def	Temp	= R16	;  
.def	Temp1	= R17
.def	BAM_R	= R18	;    BAM
.def	Count	= R19	;   
.def	Flag	= R20	;  
	.equ	Decode	= 0	;     
	.equ	BAM_F	= 1	;   BAM
.def	S_RED	= R21	;   
.def	S_GREEN	= R22	;   
.def	S_BLUE	= R23	;   
.def	S_YELLOW	= R24	;   

;----------------------------------------------------- MACROS ----------------
/*.macro	TOGGLE_IO	; TOGGLE_IO I/O, Bit
			
			sbic	@0, @1
			rjmp	_RI0
			sbi		@0, @1
			rjmp	I_END
		_RI0:
			cbi		@0, @1
		I_END:

.endmacro
*/;------------
.macro outi		; outi @0,@1
		LDI  temp, @1
		OUT  @0, temp
.endm
;--------
.macro PUSHF	; SREG -> Stack
	push Temp	; 5  
	in Temp, SREG
	push Temp
.endm
;--------
.macro POPF		; SREG <- Stack
	pop Temp	; 5  
	out SREG, Temp
	pop Temp
.endm
;------------
.macro STACK_INIT
	outi SPL, LOW(RAMEND)	;Init Stack-Pointer
;	outi SPH, HIGH(RAMEND)
.endm
;--------
.macro BRIG				;   @0   @1  (xp255) QUAD-
;	ldi		ZH,	high(EXP255*2)
;	ldi		ZL, low (EXP255*2)	;   
	ldi		ZH,	high(QUAD*2)
	ldi		ZL, low (QUAD*2)	;   
	add		ZL, @1				;    
	adc		ZH, NULL			;     
	lpm							;     
	mov		@0, R0
.endm
;--------
.macro BAM_LED				; ./.  (@1)  @0
	mov		Temp,	@0		; : BAM_LED RED, LED_R
	and		Temp,	BAM_R		;      BAM
	brne	Set_Bit				;  "1", 
	cbi		LED_PORT,	@1	;  "0" -  
	rjmp	BAM_OK
Set_Bit:
	sbi		LED_PORT,	@1	;  "1" -  
BAM_OK:
.endm
;------------
.macro	INCREASE			;   () 
		ldi Temp,	Attack
		add	@0,	Temp
		brcc	INCR1
		ldi	@0, 255
	INCR1:
.endm
;------------
.macro	DECREASE			;   () 
		subi	@0, Fading
		brcc	DECR1
		ldi	@0, 0
	DECR1:
.endm
;------------


